<template>
  <div>
    <v-row class="ma-0 pa-0">
      <v-col cols="12" xs="12" sm="12" md="12" lg="12" xl="12" align="right">
        <v-btn
          rounded
          color="tway-violet"
          class="mr-1 roboto white--text"
          @click="goConfiguration"
        >
          <strong>Configuración</strong>
        </v-btn>
        <v-btn
          rounded
          color="tway-violet"
          class="roboto white--text"
          @click="goSeguimiento"
        >
          <strong>Seguimiento</strong>
        </v-btn>
      </v-col>
    </v-row>
    <div class="tway-header-1">PRESUPUESTO</div>
    <div style="display: flex; flex-direction: row">
      <span class="tway-header-2 mr-3"
        >Presupuesto Actualizado y Seguimiento</span
      >
    </div>
    <v-row class="pa-0 ma-0">
      <v-col cols="12" xs="12" sm="12" md="12" lg="12" xl="12">
        <v-card
          outlined
          style="border-color: #731ad5; border-radius: 20px"
          class="fill-height pa-5"
        >
          <v-row class="pa-0 ma-0 mb-3" align="center">
            <v-img
              :src="require('@/assets/img/pmo/roadmap.svg')"
              class="mr-3"
              min-width="40px"
              max-width="40px"
            />
            <strong>Presupuesto Actualizado</strong>
          </v-row>
          <v-row>
            <v-col>
              <div v-if="charts.semiCircular">
                <semi-circular :data="charts.semiCircular.data">
                </semi-circular>
              </div>
              <div v-else>Cargando...</div>
            </v-col>
            <v-col>
              <div v-if="charts.pieTwo">
                <pie-two
                  :labels="charts.pieTwo.labels"
                  :datasets="charts.pieTwo.datasets"
                ></pie-two>
              </div>
              <div v-else>Cargando...</div>
            </v-col>
          </v-row>
          <v-row
            class="px-2 py-1 ma-0"
            align="center"
            justify="space-between"
            style="
              background: rgba(255, 255, 255, 0.25);
              border: 2px solid #ffffff;
              border-radius: 35px;
            "
          >
            <v-img
              :src="require('@/assets/img/pmo/reloj.svg')"
              color="white"
              min-width="40px"
              max-width="40px"
            />
          </v-row>
        </v-card>
      </v-col>
    </v-row>
    <v-row class="pa-0 ma-0">
      <v-col cols="12" xs="12" sm="12" md="12" lg="12" xl="12">
        <v-card
          outlined
          style="border-color: #731ad5; border-radius: 20px"
          class="fill-height pa-5"
        >
          <v-row class="pa-0 ma-0 mb-3" align="center">
            <v-img
              :src="require('@/assets/img/pmo/riesgos.svg')"
              class="mr-3"
              min-width="40px"
              max-width="40px"
            />
            <strong class="tway-violet--text"
              >Seguimientos y Presupuestos</strong
            >
          </v-row>
          <v-row class="pa-0 ma-0">
            <v-col cols="6" xs="6" sm="6" md="6" lg="6" xl="6">
              <v-row>
                <div v-if="charts.line" class="line-card">
                  <line-stacked
                    :labels="charts.line.labels"
                    :datasets="charts.line.datasets"
                  ></line-stacked>
                </div>
              </v-row>
            </v-col>
            <v-col cols="6" xs="6" sm="6" md="6" lg="6" xl="6">
              <div v-if="charts.vertical">
                <vertical-bar
                  :labels="charts.vertical.labels"
                  :datasets="charts.vertical.datasets"
                ></vertical-bar>
              </div>
              <div v-else>Cargando...</div>
            </v-col>
          </v-row>
          <v-row class="pt-5">
            <!-- TABLA -->
            <v-card>
              <v-card-title>
                Detalle Presupuesto
                <v-spacer></v-spacer>
                <v-text-field
                  v-model="dataTable.search"
                  append-icon="mdi-magnify"
                  label="Buscar"
                  single-line
                  hide-details
                ></v-text-field>
              </v-card-title>
              <v-data-table
                :headers="dataTable.headers"
                :items="dataTable.desserts"
                :search="dataTable.search"
              >
                <template v-slot:item.valor="{ item }">
                  <span>{{ formatCurrency(item.valor) }}</span>
                </template>
                <template v-slot:item.tipo="{ item }">
                  <span>{{ tipo(item.tipo) }}</span>
                </template>
              </v-data-table>
            </v-card>
          </v-row>
        </v-card>
      </v-col>
    </v-row>
    <v-row class="pa-0 ma-0">
      <v-col cols="12" xs="12" sm="12" md="12" lg="12" xl="12">
        <v-card
          outlined
          style="border-color: #731ad5; border-radius: 20px"
          class="fill-height pa-5"
        >
          <v-row class="pa-0 ma-0 mb-3" align="center">
            <v-img
              :src="require('@/assets/img/pmo/status.svg')"
              class="mr-3"
              min-width="40px"
              max-width="40px"
            />
            <strong class="tway-violet--text">KPIs Presupuesto</strong>
          </v-row>
          <v-row class="pa-0 ma-0">
            <v-col class="pa-0 ma-0" cols="12">
              <div style="display: flex; flex-direction: column">
                <Progress></Progress>
              </div>
            </v-col>
          </v-row>
        </v-card>
      </v-col>
    </v-row>
    <v-row class="ma-0 pa-0" justify="center">
      <v-btn rounded color="tway-violet" class="roboto white--text mt-3">
        <strong>REALIZAR EVALUACIÓN A PMO DIGITAL</strong>
      </v-btn>
    </v-row>
  </div>
</template>

<script>
import PieTwo from "@/components/charts/pmo/chartjs/PieTwo";
import LineStacked from "@/components/charts/pmo/chartjs/LineStacked.vue";
import Progress from "@/components/charts/pmo/apex/Progress.vue";
import SemiCircular from "@/components/charts/pmo/apex/SemiCircular.vue";
import BudgetService from "@/services/pmo/budget/budgetService";
import VerticalBar from "@/components/charts/pmo/apex/VerticalBar";

export default {
  components: {
    PieTwo,
    LineStacked,
    VerticalBar,
    Progress,
    SemiCircular,
  },
  data() {
    return {
      charts: {
        pieTwo: null,
        semiCircular: null,
        vertical: null,
        line: null,
      },
      dataTable: {
        search: "",
        headers: [
          {
            text: "",
            align: "start",
            sortable: false,
            value: "concepto",
          },
          { text: "Tipo", value: "tipo" },
          { text: "Valor", value: "valor" },
        ],
        desserts: [],
      },
      full: 100,
      projects: [
        {
          id: 1,
          name: "Canal de Ventas Online",
          priority: "High",
          status: "In process",
          complete: "25%",
        },
        {
          id: 2,
          name: "Rediseño Servicio Clientes",
          priority: "Normal",
          status: "In process",
          complete: "25%",
        },
        {
          id: 3,
          name: "Implentación Safe",
          priority: "High",
          status: "In process",
          complete: "35%",
        },
        {
          id: 4,
          name: "Model Engagment",
          priority: "Low",
          status: "Not Started",
          complete: "0%",
        },
      ],
    };
  },
  beforeCreate() {},
  methods: {
    goConfiguration() {
      this.$router.push({ name: "pmo-digital-budget-configuration" });
    },
    goSeguimiento() {
      this.$router.push({ name: "pmo-digital-budget-seguimiento" });
    },
    formatCurrency(value) {
      let formatter = new Intl.NumberFormat("es-CL", {
        style: "currency",
        currency: "CLP",
      });
      return formatter.format(value);
    },
    tipo(value) {
      return value == "I" ? "Inicial" : "Actualizado";
    },
  },
  mounted() {
    let me = this;

    BudgetService.getAll()
      .then((data) => {
        this.dataTable.desserts = data;
      })
      .catch((err) => console.dir(err));

    BudgetService.getInitialAndBalance()
      .then((data) => {
        let balance = data.balancePercentage;

        me.charts.semiCircular = {
          data: [balance],
        };
      })
      .catch((err) => console.dir(err));

    BudgetService.getPieTwo()
      .then((data) => {
        me.charts.pieTwo = {
          labels: [],
          datasets: [],
        };

        me.charts.pieTwo.labels = data.labels;
        me.charts.pieTwo.datasets = [
          {
            data: data.datasets,
            backgroundColor: ["red", "green", "blue"],
          },
        ];

        me.charts.vertical = {
          labels: data.labels,
          datasets: [
            {
              data: data.datasets,
              backgroundColor: ["red", "green", "blue"],
            },
          ],
        };

        me.charts.line = {
          labels: data.labels,
          datasets: [
            {
              data: data.datasets,
              backgroundColor: ["red", "green", "blue"],
            },
          ],
        };
      })
      .catch((err) => console.dir(err));
  },
};
</script>

<style scoped>
.chart-card {
  position: relative;
  background-color: #fff;
  border-radius: 6px;
  box-shadow: 0 3px 6px rgba(0, 0, 0, 0.16), 0 3px 6px rgba(0, 0, 0, 0.23);
  display: flex;
  overflow: hidden;
  flex-direction: column;
}
.line-card {
  position: relative;
  height: 80%;
  width: 80%;
  background-color: #fff;
  /*
  border-radius: 6px;
  box-shadow: 0 3px 6px rgba(0, 0, 0, 0.16), 0 3px 6px rgba(0, 0, 0, 0.23);
  */
  display: flex;
  overflow: hidden;
  flex-direction: column;
}
.hbar-card {
  position: relative;
  height: 100%;
  width: 100%;
  background-color: #fff;
  border-radius: 6px;
  box-shadow: 0 3px 6px rgba(0, 0, 0, 0.16), 0 3px 6px rgba(0, 0, 0, 0.23);
  display: flex;
  overflow: hidden;
  flex-direction: column;
}
.interpolation-card {
  position: relative;
  height: 100%;
  width: 100%;
  background-color: #fff;
  border-radius: 6px;
  box-shadow: 0 3px 6px rgba(0, 0, 0, 0.16), 0 3px 6px rgba(0, 0, 0, 0.23);
  display: flex;
  overflow: hidden;
  flex-direction: column;
}
</style>
